#include "WProgram.h"
void process_string(char instruction[], int size);
double search_string(char key, char instruction[], int string_size);
void dwell(int time);
void move(int steppin, int dirpin, int distance, int dir, int speed);
void moveXYZ(int distanceX, int distanceY, int distanceZ, int speed);
// Arduino G-code pharser
// by Mike Ellery (mellery@gmail.com)

void loop()
{
  //TODO: fix parsing so leading space isn't needed
  //TODO: fix parsing so trailing space isn't needed
  //TODO: add absolute positioning
  //TODO: Add limit switch support

  char word[20] = "";  //TODO: magic numbers are bad
  int serial_count;

  if (Serial.available() > 0)
  {
    serial_count = 0;
    while(Serial.available() > 0)
    {
      word[serial_count] = Serial.read();
      serial_count++;
    }
    Serial.print("Recieved: ");
    Serial.println(word);
    process_string(word, sizeof(word));
    Serial.print("done");
  }
}

//Put Defines here
#define stepPinX  4
#define dirPinX   5
#define stepPinY  6
#define dirPinY   7
#define stepPinZ  8
#define dirPinZ   9

const int StepsInInch = 1000; //TODO: Calibrate these
const int StepsInMM   = 50;   //TODO: Calibrate these

void setup()
{

  //Do startup stuff here
  
  Serial.begin(9600);

  pinMode(stepPinX, OUTPUT);  pinMode(dirPinX, OUTPUT);
  pinMode(stepPinY, OUTPUT);  pinMode(dirPinY, OUTPUT);
  pinMode(stepPinZ, OUTPUT);  pinMode(dirPinZ, OUTPUT);

  Serial.println("---");
  Serial.println("Starting program");  

}

//Read the string and execute instructions
void process_string(char instruction[], int size)
{
  int distanceX = 0; //TODO: struct?
  int distanceY = 0; 
  int distanceZ = 0;

  static int speed = 1650;           //TODO: 1650 just hardcoded for now
  static int units = StepsInInch;    //default to inches for units
  static boolean abs_mode = false;   //0 = incremental; 1 = absolute

  char temp_word[2] = {instruction[1], instruction[2]};
  int word = 0;

  Serial.println("processing string...");  
  if (instruction[0] == 'G')
    word = atoi(temp_word);

  switch (word) {

  //Linear Interpolation
  case 01:
     Serial.println(instruction);    
     distanceX = (int)(search_string('X', instruction, size) * units);
     distanceY = (int)(search_string('Y', instruction, size) * units);
     distanceZ = (int)(search_string('Z', instruction, size) * units);
         
     Serial.print("X distance: "); Serial.println(distanceX);     
     Serial.print("Y distance: "); Serial.println(distanceY);     
     Serial.print("Z distance: "); Serial.println(distanceZ);  
            
     moveXYZ(distanceX,distanceY,distanceZ,speed);
     instruction = NULL;
     break;

  //Dwell
  case 04:
     dwell(search_string('P', instruction, size));
     break;

  //Inches for Units
  case 20:
    units = StepsInInch; //inches
    break;

  //mm for Units    
  case 21:
    units = StepsInMM; //mm
    break;    

  //Absolute Positioning
  case 91:
    Serial.println("WARN: absolute mode not coded yet");  
    abs_mode = true;
    break;
    
  //Incremental Positioning    
  case 92:
    abs_mode = false;
    break;

  default:
   Serial.print("WARN: unknown instruction - "); 
   Serial.println(instruction);      

  }
}

//-------------------------
//look for the number that appears after the char key and return it
double search_string(char key, char instruction[], int string_size)
{
  char temp[10] = "";
  
  for (int i=0; i<string_size; i++)
    {
      if (instruction[i] == key)
      {
        i++;      
        int k = 0;
        while (instruction[i] != (' '|NULL))
        {
          temp[k] = instruction[i];
          i++; k++;
        }
        return strtod(temp, NULL);
      }
    }  
  return 0;
}

void dwell(int time)
{
   delay(time); 
}

void move(int steppin, int dirpin, int distance, int dir, int speed)
{
  digitalWrite(dirpin, dir);
  for (int i=0; i<distance; i++)
  {
    digitalWrite(steppin, HIGH);
    delayMicroseconds(2);
    digitalWrite(steppin, LOW);
    delayMicroseconds(speed);        
  }
}

//TODO: look into interupts for moving multiple axis
void moveXYZ(int distanceX, int distanceY, int distanceZ, int speed)
{
  int dirX; int dirY; int dirZ;
  
  (distanceX < 0)?(dirX=0):(dirX=1);
  (distanceY < 0)?(dirY=0):(dirY=1);
  (distanceZ < 0)?(dirZ=0):(dirZ=1);  
  
  distanceX = abs(distanceX);
  distanceY = abs(distanceY);
  distanceZ = abs(distanceZ);
  
  int slopeX = distanceX;
  int slopeY = distanceY;
  int slopeZ = distanceZ;  //TODO: add z slope

  for (int i = slopeX * slopeY; i > 1; i--)
  {
    if ((slopeX % i == 0) && (slopeY % i == 0))
    {
       slopeX /= i;
       slopeY /= i;
    }
  }

  while (distanceX > 0 | distanceY > 0 | distanceZ > 0)
  {
    move(stepPinX, dirPinX, slopeX, dirX, speed);
    move(stepPinY, dirPinY, slopeY, dirY, speed);
    move(stepPinZ, dirPinZ, slopeZ, dirZ, speed);
    distanceX -= slopeX;
    distanceY -= slopeY;
    distanceZ -= slopeZ;
  } 
}

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

