//Read the string and execute instructions
void process_string(char instruction[], int size)
{
  int distanceX = 0; //TODO: struct?
  int distanceY = 0; 
  int distanceZ = 0;

  static int speed = 1650;           //TODO: 1650 just hardcoded for now
  static int units = StepsInInch;    //default to inches for units
  static boolean abs_mode = false;   //0 = incremental; 1 = absolute

  char temp_word[2] = {instruction[1], instruction[2]};
  int word = 0;

  Serial.println("processing string...");  
  if (instruction[0] == 'G')
    word = atoi(temp_word);

  switch (word) {

  //Linear Interpolation
  case 01:
     Serial.println(instruction);    
     distanceX = (int)(search_string('X', instruction, size) * units);
     distanceY = (int)(search_string('Y', instruction, size) * units);
     distanceZ = (int)(search_string('Z', instruction, size) * units);
         
     Serial.print("X distance: "); Serial.println(distanceX);     
     Serial.print("Y distance: "); Serial.println(distanceY);     
     Serial.print("Z distance: "); Serial.println(distanceZ);  
            
     moveXYZ(distanceX,distanceY,distanceZ,speed);
     instruction = NULL;
     break;

  //Dwell
  case 04:
     dwell(search_string('P', instruction, size));
     break;

  //Inches for Units
  case 20:
    units = StepsInInch; //inches
    break;

  //mm for Units    
  case 21:
    units = StepsInMM; //mm
    break;    

  //Absolute Positioning
  case 91:
    Serial.println("WARN: absolute mode not coded yet");  
    abs_mode = true;
    break;
    
  //Incremental Positioning    
  case 92:
    abs_mode = false;
    break;

  default:
   Serial.print("WARN: unknown instruction - "); 
   Serial.println(instruction);      

  }
}

//-------------------------
//look for the number that appears after the char key and return it
double search_string(char key, char instruction[], int string_size)
{
  char temp[10] = "";
  
  for (int i=0; i<string_size; i++)
    {
      if (instruction[i] == key)
      {
        i++;      
        int k = 0;
        while (instruction[i] != (' '|NULL))
        {
          temp[k] = instruction[i];
          i++; k++;
        }
        return strtod(temp, NULL);
      }
    }  
  return 0;
}
